        #declare BlackRubber=texture{
                             pigment{color rgb<.1,.1,.1>}
                             finish{specular .5 roughness .09 diffuse .7}
                             }

#declare WhitePlastic=texture{
                             pigment{color rgb<1,1,1>}
                             finish{Shiny}
                             }
#declare Glass=texture{
                       pigment{rgbf<.98,.98,.98,.98>}
                       finish{specular .9 roughness .0001 diffuse 1 refraction 1 ior 1.5
                       reflection .14 caustics .2 fade_distance .03 fade_power 1}
                       }
#declare MattressTex=texture{
                             pigment{gradient x color_map{
                             [0,.22 color rgb<.3,.3,.9> color rgb<.3,.3,.9>]
                             [.23,.54 color rgb<.87,.8,.8> color rgb<.87,.8,.8>]
                             [.55,84 color rgb<.3,.3,.9> color rgb<.3,.3,.9>]
                             [.85,.99 color rgb<.87,.8,.8> color rgb<.87,.8,.8>]
                             }
                             }
                             finish{specular 0 diffuse .8 brilliance 1.7}
                             normal{bumps .33 scale<.42,.42,.42>}
                             }

#declare RustyIron=texture{
                           pigment{crackle color_map{
                             [0,.4 color rgb<.5,.3,.3> color rgb<.45,.3,.3>]
                             [.55,.95 color rgb<.75,.6,.6> color rgb<.75,.6,.6>]
                             }
                             turbulence .4
                             }
                             finish{specular .05 diffuse .9 brilliance 1}
                             normal{gradient x turbulence .8 omega .85 scale<.5,.5,.5>}
                             scale<.2,.2,.2>
                             }
#declare Steel=texture{
                             pigment{color rgb<.8,.8,.8>}
                             finish{specular .08 roughness .015 diffuse .6}
                             }

#declare PolishedSteel=texture{
                             pigment{color rgb<.8,.8,.8>}
                             finish{specular .7 roughness .045 diffuse .5}
                             normal{wrinkles .6 scale<.01,1,.01> rotate z*-45}
                             }

#declare WaterTex=texture{
                             pigment{color rgbf<.8,.8,.75,.8>}
                             finish{specular .8 roughness .000015 diffuse .6
                             reflection .35 ior 2}
                             }
#declare BadWater=texture{
                             pigment{color rgbf<.9,.9,.9,.96>}
                             finish{specular .1 roughness .000015 diffuse .1 refraction 1 ior 1.2 caustics .2}
                             }
#declare Iron=texture{
                             pigment{color rgb<.8,.8,.8>}
                             finish{specular .6 roughness .015 diffuse .8}
                             normal{spotted bump_size .3 scale<.01,.01,.01>}
}

#declare OldMetal=texture{
                             pigment{wood color_map{
                             [0,.2 color rgb<.45,.32,.3> color rgb<.55,.4,.4>]
                             [.4,.5 color rgb<.2,.1,.1> color rgb<.4,.35,.3>]
                             [.5,.9 color rgb<.4,.35,.35> color rgb<.6,.55,.45>]
                             [.9,1 color rgb<.6,.55,.4> color rgb<.45,.32.3>]
                             }
                             turbulence .2 octaves 3 omega .7
                             }
                             finish{specular .5 roughness .02 diffuse .6}
                             scale<.15,.15,.15>
                             }


#declare BackWallTex=        texture{
                             pigment{color rgb<.5,.5,.5 >}
                             }


                             texture{

                             pigment{image_map{ gif "water.gif" interpolate 2  filter all .35}}
                             translate<-.5,0,0> scale<(2*Halfwidth),Roofheight,1>}

                             texture{
                             pigment{image_map{ gif "poster1.gif" interpolate 2 filter 255 1 once }}
                             scale<.2,.4,.2> translate<.34,.35,0>
                             translate<-.5,0,0> scale<(2*Halfwidth),Roofheight,1>}

                             texture{
                             pigment{image_map{ gif "time1.gif"  filter 255 1}}


                             normal{bump_map{ gif "wbscr.gif" interpolate 2 bump_size 1.7}}
                             finish{specular .3 roughness .07}
                             translate<-.5,0,0> scale<(2*Halfwidth),Roofheight,1>

                             }

#declare RightWallTex=texture{pigment{color rgb<.5,.5,.5>}}

                             texture{
                             pigment{color rgb<.5,.5,.5>}
                             }
                             texture{
                             pigment{image_map{ gif "ritemap.gif" interpolate 2 filter all .354     }}

                             normal{bump_map{ gif "wrscr.gif" interpolate 2 bump_size 1.7}}
                             finish{specular .5 roughness .07}
                             translate<-.5,0,0> scale<(2*Halfwidth),Roofheight,1>
                             }

#declare FloorTex=texture{pigment{color rgb<.5,.5,.5>}}

                             texture{
                             pigment{color rgb<.5,.5,.5>}
                             pigment{image_map{ gif "fl-map2.gif" interpolate 2      }}
                             finish{specular .5 roughness .07}
                             translate<-.5,-.5,0> rotate x*90 scale<(2*Halfwidth),1,(2*Halfwidth)>
                             }
/*
#declare BackWallTex=texture{QuickTex}
#declare RightWallTex=texture{QuickTex}
*/
#declare Torch=union{
	#if (Torches > 0)difference{sphere{<0,0,0>1}
				sphere{<0,0,0>1	scale<.95,.95,.95>}
				texture{ClearPlastic finish{ambient .75}}scale<.1,.19,.1> no_shadow
				}//end difference
	#end
#if (Torches > 1 | Torches = -1)				object{TorchLight translate z*-.05} #end

		}//end union1

//===============================================================================

#declare IRadius=.023
#declare ORadius=.2
#declare Length=1.65
#declare QuarterTurn=intersection{torus{ORadius,IRadius rotate<-90,90,0>}
				  box{<-1,0,0>,<1,1,-1>}
				}
#declare LadderRail=union{object{QuarterTurn}
			  cylinder{<0,0,0>,<0,-Length,0>,IRadius
					translate<0,0,-ORadius>
					}
			  object{QuarterTurn rotate x*-90 translate<0,-Length,0>}
			  texture{RustyIron}
			}
#declare LadderRung=cylinder{<-.25,0,0><.25,0,0>(IRadius/2) translate z*-ORadius}
#declare Ladder=union{object{LadderRail translate x*-.25}
			object{LadderRail translate x*.25}
			object{LadderRung translate y*-.0}
			object{LadderRung translate y*-.3}
			object{LadderRung translate y*-.6}
			object{LadderRung translate y*-.9}
			object{LadderRung translate y*-1.2}
			object{LadderRung translate y*-1.5}

			texture{Steel}
			}
//=============================================================================

#declare DoorwayCutter=union{
                             cylinder{<0,0,10><0,0,-10>.5 translate y*.8}
                             box{<-.5,0,-10><.5,.8,10>}
                             }


#declare DoorTop=union{
                       box{<-.6,0,0><.6,.02,.12>}
                       cylinder{<0,0,.06><0,.6,.06>.015 translate x*-.4}
                       cylinder{<0,0,.06><0,.6,.06>.015 translate x*-.2}
                       cylinder{<0,0,.06><0,.6,.06>.015 translate x*0}
                       cylinder{<0,0,.06><0,.6,.06>.015 translate x*.2}
                       cylinder{<0,0,.06><0,.6,.06>.015 translate x*.4}

                       texture{Steel}}
#declare Door=union{

                    difference{
                               union{
                                     box{<-.49,.02,-.01><.4,.79,.13> texture{Steel}}
                                     box{<-.45,.06,-.015><.36,.75,.135> texture{PolishedSteel}}
                                     }
                    box{<-.12,.6,-10><.12,.75,10> texture{Steel}}
                    }
                    cylinder{<0,0,0><0,.8,0> .07 translate <.43,0,.07> texture{Steel}}
                    box{<-.12,.6,-.01><.12,.75,.135> texture{Glass}}
                    object{DoorTop translate <0,.8,.2>              }
                    }


#declare Barswidth=2
#declare BarsCutter=cylinder{<0,0,0><0,20,0>Barswidth/2}
#declare Bar=cylinder{<0,0,2><0,0,-2>.04}
#declare Bars=union{
                    #declare Number=7
                    #declare Spacing=Barswidth/Number
                   object{Bar translate x*Spacing*1}
                   object{Bar translate x*Spacing*2}
                   object{Bar translate x*Spacing*3}
                   object{Bar translate x*Spacing*4}
                   object{Bar translate x*Spacing*5}
                   object{Bar translate x*Spacing*6}
                   object{Bar translate x*Spacing*7}
                   translate -x*((Spacing*(Number/2))+Spacing)

                   }

//=============================================================================

#declare Tray=difference{
                         box{<-.5,0,-.4><.5,.025,.4>}
                         box{<-.49,.01,-.39><.49,.9,.39>}
                         texture{pigment{DMFWood1}}
                         scale<.8,.8,.8>}

#declare Plate=difference{cone{<0,0,0>.15<0,.03,0>.25}
			cone{<0,.005,0>.15<0,.035,0>.26}
			texture{QuickTex2}
			}
#declare RiceBowl=sor{
              8
              <0,0>
              <1,0>
              <0.5,.25>
              <.7,.7>
              <1.3,.8>
              <2,1.4>
              <2.5,2.3>
              <2.5,3>
              //<0,3.001>
              texture{QuickTex}
              scale<.04,.04,.04>
         }

#declare Cup=
                   difference{cylinder{<0,0,0><0,.14,0>.04}
			cone{<0,.01,0>.027<0,.141,0>.034}
                        texture{Glass}
                        }
                  
#declare Chopstick=union{
         cone{<0,0,0>.003<0,0,.11>.002}
         box{<-.003,-.003,.05><.003,.003,-.1>}
         texture{WhitePlastic}
         }
#declare Chopsticks=union{
         object{Chopstick translate<0,0,-.16> rotate y*-12}
         object{Chopstick translate<0,0,-.13  > rotate y*7}
         }
#declare FoodScene=union{
                         object{Tray}
			//object{Plate translate<-.2,.01,-.1>}
			object{Cup /*rotate z*90 translate y*.02 rotate y*-30 */translate<.23,.01,.15>}    
                        object{RiceBowl translate<-.2,.01,-.1>}
                        object{Chopsticks translate<-.03,.01,.1>}
}

#declare Leg=union{cylinder{<0,0,0><0,.6,0>.02 texture{QuickTex}}
		   cone{<0,0,0>.04,<0,.06,0>.028 texture{BlackRubber}}
                   }
#declare BedBox1=

difference{
#declare Width=1
#declare Length=1.7
            box{<-(Width/2),0,-(Length/2)><Width/2,.07,Length/2>}
            box{<-(Width/2),0,-(Length/2)><Width/2,.07,Length/2>
                    scale<.94,2,.94> translate y*-.02}
                    texture{DMFWood2}
                    }
#declare BedBox=union{
         object{BedBox1}
         #declare Spacing=Length/9
union{
cylinder{<-(Width/2),.035,-(Length/2)><Width/2,.035,-(Length/2)>.01 translate z*Spacing*0}
cylinder{<-(Width/2),.035,-(Length/2)><Width/2,.035,-(Length/2)>.01 translate z*Spacing*1}
cylinder{<-(Width/2),.035,-(Length/2)><Width/2,.035,-(Length/2)>.01 translate z*Spacing*2}
cylinder{<-(Width/2),.035,-(Length/2)><Width/2,.035,-(Length/2)>.01 translate z*Spacing*3}
cylinder{<-(Width/2),.035,-(Length/2)><Width/2,.035,-(Length/2)>.01 translate z*Spacing*4}
cylinder{<-(Width/2),.035,-(Length/2)><Width/2,.035,-(Length/2)>.01 translate z*Spacing*5}
cylinder{<-(Width/2),.035,-(Length/2)><Width/2,.035,-(Length/2)>.01 translate z*Spacing*6}
cylinder{<-(Width/2),.035,-(Length/2)><Width/2,.035,-(Length/2)>.01 translate z*Spacing*7}
cylinder{<-(Width/2),.035,-(Length/2)><Width/2,.035,-(Length/2)>.01 translate z*Spacing*8}
scale<1.05,1,1> //make them stick out a bit
texture{Steel}

        }
}
#declare Mattress=superellipsoid{<.3,.3> translate<0,.5,0> scale<Width,.07,Length>
                     scale<1,1.15,1>
                     scale<.5,0,.5>     //just seems to need it :-|
                     texture{MattressTex scale<.2,.2,.2>}
                     }


#declare Bed=union{
                   object{BedBox translate y*.3 }
                   object{Mattress translate <0,.4,0> rotate y*18 translate<-.19,.0,.15>}
                   //y*.36
                   object{Leg translate <-(Width/2),0,-(Length/2)>}
                   object{Leg translate <-(Width/2),0,(Length/2)>}
                   object{Leg translate <(Width/2),0,-(Length/2)>}
                   object{Leg translate <(Width/2),0,(Length/2)>}
                   }


#declare DrainCutter=union{
                           box{<-.02,-1,-.17><.02,1,.17>}
                           cylinder{<0,-1,-.17><0,1,-.17>.02}
                           cylinder{<0,-1,.17><0,1,.17>.02}
                           }

#declare Drain=difference{
                          box{<-.2,0,-.2><.2,.06,.2>}
                          object{DrainCutter translate x*-.17}
                          object{DrainCutter translate x*-.09}
                          object{DrainCutter translate x*-.01}
                          object{DrainCutter translate x*.07}
                          object{DrainCutter translate x*.15}
                          texture{OldMetal}
bounded_by{box{<-.21,-.01,-.21><.21,.061,.21>}}
                        }
#declare DrainSpace=box{<-.2,-1,-.2><.2,.2,.2>}


//==========================================================================
#declare Nut= difference{
         cylinder{<0,0,0><0,0,-.04>0.06}
         plane{-y,0 translate y*.03 rotate z*0}
         plane{-y,0 translate y*.03 rotate z*60}
         plane{-y,0 translate y*.03 rotate z*120}
         plane{-y,0 translate y*.03 rotate z*180}
         plane{-y,0 translate y*.03 rotate z*240}
         plane{-y,0 translate y*.03 rotate z*300}
         texture{Iron}
        }

#declare Hotwater=union{
#declare OffSet=.04
#declare Bracket=union{
         torus{.02,.005 rotate x*-90}
         cylinder{<.02,0,0><.02+OffSet,0,0>.006}
         texture{BlackRubber}
}

#declare UpPos=-.45
         cylinder{<0,0,-3.15><0,0,3.15>.015}
         cylinder{<0,0,0><0,1.7,0>.015 translate z*UpPos}
         object{Nut translate z*(UpPos+.06)}
         object{Nut translate z*(UpPos-.06)}
         object{Bracket translate z*-3}
         object{Bracket translate z*-1.5}
         object{Bracket translate z*0}
         object{Bracket translate z*1.5}
         object{Bracket translate z*3}
translate x*-OffSet
}


#declare Coldwater=union{
#declare OffSet=.08
#declare Bracket=union{
         torus{.02,.005 rotate x*-90}
         cylinder{<.02,0,0><.02+OffSet,0,0>.006}
         texture{BlackRubber}
         }
#declare UpPipe=union{
         cylinder{<0,0,0><0,.7,0>.015 }
         #declare QT=intersection{torus{0.02,.015 rotate<-90,0,0>}
				  box{<-1,0,-1>,<0,1,1>}
				}
         object{QT translate<.02,.7,0>}
         object{QT rotate z*180 translate<.02,.75,0>}//the rotation moves it down
         }
#declare UpPos=-.3
         cylinder{<0,0,-3.15><0,0,3.15>.015}
         object{UpPipe translate z*UpPos}
         object{Nut translate z*(UpPos+.06)}
         object{Nut translate z*(UpPos-.06)}
         object{Bracket translate z*-31}
         object{Bracket translate z*-1.7}
         object{Bracket translate z*.2}
         object{Bracket translate z*1.15}
         object{Bracket translate z*2.8}
translate x*-OffSet
translate y*-.09
}

#declare Tap =union{
         cylinder{<-.1,0,0><.03,0,0>.15 scale <1,.6,1> texture{OldMetal}}
         sphere{<0,0,0>.13 scale<.25,.6,1> translate x*-.1}
         object{Nut rotate y*-90  translate x*-.17}
         union{
               cylinder{<0,0,0>,<0,0,-.2>.022}
               sphere{<0,0,0>.022}
               sphere{<0,0,-.2>.022}
               scale<.1,1,1>
               translate x*-.17  rotate x*-120
               texture{BlackRubber}
}
texture{Steel}
}

#declare Head=union{
         object{QT rotate z*-90}
         cylinder{<0,.02,0><-.3,.02,0>.015}
         torus{.02,.005 rotate x*-90 rotate y*90 translate<-.07,.02,0> texture{BlackRubber}}
         cylinder{<-.08,.044,0><.05,.25,0>.005 texture{BlackRubber}}
         object{QT translate x*-.3}
         cylinder{<-.32,0,0><-.32,-.07,0>.015}
         }

#declare Piping=union{
object{Hotwater}
object{Coldwater}
object{Tap translate <0,.75,-.375>}
object{Head scale<1,1,1>translate <-.06,1.7,-.45>}
texture{OldMetal}
}
//==============================================================================
#declare Puddles=height_field{
                       gif "water1.gif" water_level .001
                       translate<-.5,0,-.5> scale<(2*Halfwidth),.0035,(2*Halfwidth)>
                       texture{WaterTex}
}
